package content.data

enum class MeatState {
    INEDIBLE_RAW,
    INEDIBLE_BURNT,
    INEDIBLE_SPECIAL, // could be a quest item
    EDIBLE_COOKED,
}

enum class Meat(val id: Int, val state: MeatState) {
    ENCHANTED_BEEF(522, MeatState.INEDIBLE_SPECIAL),
    ENCHANTED_RAT_MEAT(523, MeatState.INEDIBLE_SPECIAL),
    ENCHANTED_BEAR_MEAT(524, MeatState.INEDIBLE_SPECIAL),
    ENCHANTED_CHICKEN(525, MeatState.INEDIBLE_SPECIAL),
    RAW_UGTHANKI_MEAT(1859, MeatState.INEDIBLE_RAW),
    UGTHANKI_MEAT(1861, MeatState.EDIBLE_COOKED),
    RAW_BEEF(2132, MeatState.INEDIBLE_RAW),
    RAW_RAT_MEAT(2134, MeatState.INEDIBLE_RAW),
    RAW_BEAR_MEAT(2136, MeatState.INEDIBLE_RAW),
    RAW_CHICKEN(2138, MeatState.INEDIBLE_RAW),
    COOKED_CHICKEN(2140, MeatState.EDIBLE_COOKED),
    BURNT_CHICKEN(2140, MeatState.INEDIBLE_BURNT),
    COOKED_MEAT(2142, MeatState.EDIBLE_COOKED),
    BURNT_MEAT(2146, MeatState.INEDIBLE_BURNT),
    THIN_SNAIL_MEAT(3369, MeatState.EDIBLE_COOKED),
    LEAN_SNAIL_MEAT(3371, MeatState.EDIBLE_COOKED),
    FAT_SNAIL_MEAT(3373, MeatState.EDIBLE_COOKED),
    RAW_BEEF_UNDEAD(4287, MeatState.INEDIBLE_RAW),
    RAW_CHICKEN_UNDEAD(4289, MeatState.INEDIBLE_RAW),
    COOKED_CHICKEN_UNDEAD(4291, MeatState.EDIBLE_COOKED),
    COOKED_MEAT_UNDEAD(4293, MeatState.EDIBLE_COOKED),
    RAW_CRAB_MEAT(7518, MeatState.INEDIBLE_RAW),
    BURNT_CRAB_MEAT(7520, MeatState.INEDIBLE_BURNT),
    COOKED_CRAB_MEAT_5(7521, MeatState.EDIBLE_COOKED),
    COOKED_CRAB_MEAT_4(7523, MeatState.EDIBLE_COOKED),
    COOKED_CRAB_MEAT_3(7524, MeatState.EDIBLE_COOKED),
    COOKED_CRAB_MEAT_2(7525, MeatState.EDIBLE_COOKED),
    COOKED_CRAB_MEAT_1(7526, MeatState.EDIBLE_COOKED),
    GROUND_CRAB_MEAT(7527, MeatState.INEDIBLE_RAW),
    LOCUST_MEAT(9052, MeatState.EDIBLE_COOKED),
    RAW_BIRD_MEAT(9978, MeatState.INEDIBLE_RAW),
    ROAST_BIRD_MEAT(9980, MeatState.EDIBLE_COOKED),
    BURNT_BIRD_MEAT(9982, MeatState.INEDIBLE_BURNT),
    SKEWERED_BIRD_MEAT(9982, MeatState.INEDIBLE_RAW),
    RAW_BEAST_MEAT(9986, MeatState.INEDIBLE_RAW),
    ROAST_BEAST_MEAT(9988, MeatState.EDIBLE_COOKED),
    BURNT_BEAST_MEAT(9990, MeatState.INEDIBLE_BURNT),
    RAW_YAK_MEAT(10816, MeatState.INEDIBLE_RAW),
    RAW_PAWYA_MEAT(12535, MeatState.INEDIBLE_RAW),
    ENCHANTED_PAWYA_MEAT(12546, MeatState.INEDIBLE_SPECIAL);
}