package content.global.skill.fishing

import core.game.world.map.Location

enum class FishSpots(vararg val locations: Location) {
    CATHERBY(
        Location(2844, 3429, 0),
        Location(2839, 3431, 0),
        Location(2836, 3431, 0),
        Location(2837, 3431, 0),
        Location(2838, 3431, 0),
        Location(2839, 3431, 0),
        Location(2840, 3431, 0),
        Location(2844, 3429, 0),
        Location(2845, 3429, 0),
        Location(2846, 3429, 0),
        Location(2853, 3423, 0),
        Location(2854, 3423, 0),
        Location(2855, 3423, 0),
        Location(2859, 3426, 0),
        Location(2860, 3426, 0)
    ),
    ENTRANA(
        Location(2842, 3359, 0),
        Location(2843, 3359, 0),
        Location(2844, 3359, 0),
        Location(2847, 3361, 0),
        Location(2848, 3361, 0),
        Location(2849, 3361, 0),
        Location(2850, 3361, 0)
    ),
    ENTRANA_PLATFORM(
        Location(2879, 3334, 0),
        Location(2879, 3335, 0),
        Location(2879, 3338, 0),
        Location(2879, 3339, 0),
        Location(2877, 3342, 0),
        Location(2876, 3342, 0),
        Location(2875, 3342, 0),
        Location(2875, 3331, 0),
        Location(2876, 3331, 0),
        Location(2877, 3331, 0)
    ),
    SEERS(
        Location(2714, 3533, 0),
        Location(2714, 3532, 0),
        Location(2726, 3524, 0),
        Location(2727, 3524, 0),
        Location(2728, 3524, 0)
    ),
    DRAYNOR(
        Location(3085, 3230, 0),
        Location(3086, 3227, 0)
    ),
    BARBARIAN(
        Location(3110, 3432, 0),
        Location(3110, 3433, 0),
        Location(3110, 3434, 0),
        Location(3104, 3425, 0),
        Location(3104, 3424, 0)
    ),
    LUMBRIDGE(
        Location(3239, 3243, 0),
        Location(3239, 3241, 0),
        Location(3239, 3242, 0),
        Location(3238, 3251, 0),
        Location(3238, 3252, 0),
        Location(3238, 3253, 0)
    ),
    LUMBRIDGE_SWAMP(
        Location(3242, 3143, 0),
        Location(3242, 3148, 0),
        Location(3241, 3148, 0),
        Location(3240, 3147, 0),
        Location(3240, 3146, 0),
        Location(3244, 3150, 0),
        Location(3245, 3152, 0),
        Location(3246, 3155, 0),
        Location(3246, 3156, 0),
        Location(3239, 3241, 0)
    ),
    LUMBRIDGE_MARSH(
        Location(3169, 3266, 0),
        Location(3168, 3266, 0),
        Location(3174, 3274, 0),
        Location(3173, 3274, 0)
    ),
    ALKHARID(
        Location(3267, 3148, 0),
        Location(3268, 3147, 0),
        Location(3276, 3140, 0),
        Location(3275, 3140, 0)
    ),
    FISHING_GUILD(
        Location(2612, 3411, 0),
        Location(2602, 3423, 0),
        Location(2602, 3411, 0),
        Location(2602, 3412, 0),
        Location(2602, 3414, 0),
        Location(2602, 3415, 0),
        Location(2603, 3417, 0),
        Location(2604, 3417, 0),
        Location(2605, 3416, 0),
        Location(2606, 3416, 0),
        Location(2607, 3416, 0),
        Location(2608, 3416, 0),
        Location(2609, 3416, 0),
        Location(2610, 3416, 0),
        Location(2611, 3416, 0),
        Location(2612, 3415, 0),
        Location(2612, 3414, 0),
        Location(2607, 3410, 0),
        Location(2606, 3410, 0),
        Location(2605, 3410, 0),
        Location(2599, 3419, 0),
        Location(2600, 3419, 0),
        Location(2602, 3419, 0),
        Location(2603, 3419, 0),
        Location(2604, 3419, 0),
        Location(2605, 3420, 0),
        Location(2605, 3421, 0),
        Location(2604, 3422, 0),
        Location(2603, 3422, 0),
        Location(2602, 3422, 0),
        Location(2601, 3422, 0),
        Location(2605, 3424, 0),
        Location(2605, 3425, 0),
        Location(2602, 3426, 0),
        Location(2603, 3426, 0),
        Location(2604, 3426, 0)
    ),
    GNOME(
        Location(2388, 3424, 0),
        Location(2390, 3422, 0),
        Location(2391, 3421, 0),
        Location(2382, 3413, 0),
        Location(2382, 3414, 0),
        Location(2382, 3415, 0)
    ),
    CASTLEWAR(
        Location(2465, 3156, 0),
        Location(2464, 3155, 0),
        Location(2468, 3157, 0),
        Location(2469, 3157, 0),
        Location(2471, 3158, 0),
        Location(2472, 3156, 0),
        Location(2462, 3145, 0),
        Location(2461, 3150, 0),
        Location(2461, 3151, 0)
    ),
    SHILO(
        Location(2460, 3144, 0),
        Location(2461, 3150, 0),
        Location(2461, 3151, 0),
        Location(2853, 2977, 0),
        Location(2854, 2977, 0),
        Location(2855, 2977, 0),
        Location(2856, 2977, 0),
        Location(2858, 2976, 0),
        Location(2859, 2976, 0),
        Location(2860, 2976, 0),
        Location(2863, 2975, 0),
        Location(2863, 2975, 0),
        Location(2864, 2975, 0),
        Location(2865, 2972, 0),
        Location(2860, 2972, 0),
        Location(2855, 2974, 0),
        Location(2852, 2973, 0)
    ),
    KARAMJA(
        Location(2923, 3178, 0),
        Location(2923, 3179, 0),
        Location(2923, 3180, 0),
        Location(2924, 3181, 0),
        Location(2925, 3181, 0),
        Location(2926, 3180, 0),
        Location(2926, 3179, 0),
        Location(2926, 3178, 0),
        Location(2926, 3177, 0),
        Location(2926, 3176, 0)
    ),
    PISCATORIS(
        Location(2341, 3702, 0),
        Location(2342, 3702, 0),
        Location(2343, 3702, 0),
        Location(2344, 3702, 0),
        Location(2345, 3702, 0),
        Location(2346, 3702, 0),
        Location(2347, 3702, 0),
        Location(2349, 3702, 0),
        Location(2352, 3703, 0)
    ),
    TUTORIAL_ISLAND(
        Location(3101, 3092, 0)
    ),
    WILDERNESS_AREA(
        Location(3187, 3927, 0),
        Location(3185, 3926, 0),
        Location(3183, 3926, 0),
        Location(3181, 3926, 0)
    );
    
    companion object {
        private val locs: ArrayList<Location> = ArrayList()
        private val locMap: HashMap<Location, FishSpots> = HashMap()
        init {
            for(value in values()) {
                for(loc in value.locations) {
                    locMap[loc] = value
                    locs.add(loc)
                }
            }
        }

        @JvmStatic
        fun forLocation(loc: Location): FishSpots? {
            return if (locMap[loc] == null) {
                TUTORIAL_ISLAND
            } else {
                locMap[loc]
            }
        }
    }
}